# 5.0.0

Release date: `2021-02-19`

## Core

- [NXDRIVE-1359](https://jira.nuxeo.com/browse/NXDRIVE-1359): Reduce the complexity of `Processor._execute()`
- [NXDRIVE-2140](https://jira.nuxeo.com/browse/NXDRIVE-2140): Handle documents with non-standard or empty digest
- [NXDRIVE-2442](https://jira.nuxeo.com/browse/NXDRIVE-2442): Implement mutual TLS authentication
- [NXDRIVE-2487](https://jira.nuxeo.com/browse/NXDRIVE-2487): Always enable Sentry on alpha versions or when the app is ran from sources
- [NXDRIVE-2501](https://jira.nuxeo.com/browse/NXDRIVE-2501): Fix the "Open remote" action on conflicted folderish documents
- [NXDRIVE-2508](https://jira.nuxeo.com/browse/NXDRIVE-2508): Fix mypy issues following the update to mypy 0.800
- [NXDRIVE-2511](https://jira.nuxeo.com/browse/NXDRIVE-2511): Use constants for audit events
- [NXDRIVE-2513](https://jira.nuxeo.com/browse/NXDRIVE-2513): Always enable DEBUG log level on alpha versions or when the app is ran from sources
- [NXDRIVE-2515](https://jira.nuxeo.com/browse/NXDRIVE-2515): Log the previous version when displaying release notes
- [NXDRIVE-2518](https://jira.nuxeo.com/browse/NXDRIVE-2518): Drop support for macOS 10.12 (Sierra)
- [NXDRIVE-2524](https://jira.nuxeo.com/browse/NXDRIVE-2524): [GNU/Linux] WAL journal mode cause manager database corruption
- [NXDRIVE-2525](https://jira.nuxeo.com/browse/NXDRIVE-2525): Do not try to list parts when an upload was already completed on S3

### Direct Edit

- [NXDRIVE-2517](https://jira.nuxeo.com/browse/NXDRIVE-2517): Fix Qt slot signature preventing to edit custom `xpath`

## GUI

- [NXDRIVE-2351](https://jira.nuxeo.com/browse/NXDRIVE-2351): Align Colors

## Packaging / Build

- [NXDRIVE-2015](https://jira.nuxeo.com/browse/NXDRIVE-2015): Upgrade from Python 3.8.6 to 3.9.1

## Tests

- [NXDRIVE-2509](https://jira.nuxeo.com/browse/NXDRIVE-2509): Remove old report before starting a test

## Minor Changes

- Upgraded `boto3` from 1.16.25 to 1.17.0
- Upgraded `botocore` from 1.19.25 to 1.20.0
- Upgraded `cffi` from 1.14.4 to 1.14.5
- Upgraded `pycryptodomex` from 3.9.9 to 3.10.1
- Upgraded `pyyaml` from 5.3.1 to 5.4.1
- Upgraded `sentry-sdk` from 0.19.5 to 0.20.3
- Upgraded `urllib3` from 1.26.2 to 1.26.3

## Technical Changes

- Removed `Application.show_release_notes()` (now private)
- Added `Options.cert_file`
- Added `Options.cert_key_file`
- Added `Options.is_alpha`
- Added `Options.light_icons`
- Removed `QMLDriveApi.get_auto_start()`. Use `Manager.get_auto_start()` instead.
- Removed `QMLDriveApi.get_auto_update()`. Use `Manager.get_auto_update()` instead.
- Removed `QMLDriveApi.get_direct_edit_auto_lock()`. Use `Manager.get_direct_edit_auto_lock()` instead.
- Removed `QMLDriveApi.get_log_level()`. Use `Manager.get_log_level()` instead.
- Removed `QMLDriveApi.get_update_channel()`. Use `Manager.get_update_channel()` instead.
- Removed `QMLDriveApi.set_auto_start()`. Use `Manager.set_auto_start()` instead.
- Removed `QMLDriveApi.set_auto_update()`. Use `Manager.set_auto_update()` instead.
- Removed `QMLDriveApi.set_direct_edit_auto_lock()`. Use `Manager.set_direct_edit_auto_lock()` instead.
- Removed `QMLDriveApi.set_log_level()`. Use `Manager.set_log_level()` instead.
- Removed `QMLDriveApi.set_update_channel()`. Use `Manager.set_update_channel()` instead.
- Added `cert` keyword argument to `Remote.__init__()`
- Added constants.py::`DigestStatus`
- Added engine/watcher/constants.py
- Added exceptions.py::`EncryptedSSLCertificateKey`
- Added exceptions.py::`MissingClientSSLCertificate`
- Removed logging_config.py::`DEFAULT_LEVEL_CONSOLE`. Use options.py::`DEFAULT_LOG_LEVEL_CONSOLE` instead.
- Removed logging_config.py::`DEFAULT_LEVEL_FILE`. Use options.py::`DEFAULT_LOG_LEVEL_FILE` instead.
- Removed logging_config.py::`check_level()`
- Removed logging_config.py::`update_logger_console()`
- Removed logging_config.py::`update_logger_file()`
- Added options.py::`DEFAULT_LOG_LEVEL_CONSOLE`
- Added options.py::`DEFAULT_LOG_LEVEL_FILE`
- Added options.py::`validate_cert_path()`
- Added options.py::`validate_use_sentry()`
- Added utils.py::`client_certificate()`
- Added utils.py::`digest_status()`
- Changed the return type of utils.py::`test_url()` from `bool` to `str`
