# 5.1.1

Release date: `2021-04-15`

## Core

- [NXDRIVE-2443](https://jira.nuxeo.com/browse/NXDRIVE-2443): Bypass all OS errors in `disk_space()`
- [NXDRIVE-2463](https://jira.nuxeo.com/browse/NXDRIVE-2463): Add support for idempotent requests
- [NXDRIVE-2558](https://jira.nuxeo.com/browse/NXDRIVE-2558): Add a custom metric for hard crashes
- [NXDRIVE-2574](https://jira.nuxeo.com/browse/NXDRIVE-2574): Handle pair state deleted-moved as a remotely created
- [NXDRIVE-2575](https://jira.nuxeo.com/browse/NXDRIVE-2575): Fix error message when `get_metadata_infos()` would likely fail
- [NXDRIVE-2587](https://jira.nuxeo.com/browse/NXDRIVE-2587): Skip conflict resolution on non-standard digest
- [NXDRIVE-2588](https://jira.nuxeo.com/browse/NXDRIVE-2588): Handle `parent_remotely_deleted` state in the local watcher
- [NXDRIVE-2589](https://jira.nuxeo.com/browse/NXDRIVE-2589): Lower logging level of installer integrity check failure
- [NXDRIVE-2590](https://jira.nuxeo.com/browse/NXDRIVE-2590): Restart upload on still outdated refreshed AWS credentials
- [NXDRIVE-2595](https://jira.nuxeo.com/browse/NXDRIVE-2595): Restart transfer from the ground when resuming with an invalid batch ID
- [NXDRIVE-2597](https://jira.nuxeo.com/browse/NXDRIVE-2597): Use a LRU cache for translation strings
- [NXDRIVE-2598](https://jira.nuxeo.com/browse/NXDRIVE-2598): Retry S3 non-chunked uploads on expired credentials

### Direct Transfer

- [NXDRIVE-2427](https://jira.nuxeo.com/browse/NXDRIVE-2427): Make the end of session notification clickable
- [NXDRIVE-2572](https://jira.nuxeo.com/browse/NXDRIVE-2572): Use `AddChildren` permission instead of `ReadWrite` for entitlement of places where one can upload into
- [NXDRIVE-2585](https://jira.nuxeo.com/browse/NXDRIVE-2585): Rename the file size label in the monitoring
- [NXDRIVE-2591](https://jira.nuxeo.com/browse/NXDRIVE-2591): Hide the CSV export icon when no documents were uploaded

## GUI

- [NXDRIVE-2579](https://jira.nuxeo.com/browse/NXDRIVE-2579): Rename systray menu labels
- [NXDRIVE-2580](https://jira.nuxeo.com/browse/NXDRIVE-2580): Reword the local file purgation label in the account removal window
- [NXDRIVE-2586](https://jira.nuxeo.com/browse/NXDRIVE-2586): Reword Advanced Settings

## Packaging / Build

- [NXDRIVE-2163](https://jira.nuxeo.com/browse/NXDRIVE-2163): [macOS] Move the application to `$HOME/Applications` on auto-update
- [NXDRIVE-2594](https://jira.nuxeo.com/browse/NXDRIVE-2594): Upgrade from Python 3.9.2 to 3.9.4
- [NXDRIVE-2599](https://jira.nuxeo.com/browse/NXDRIVE-2599): Enhance the auto-update check script

## Tests

- [NXDRIVE-2333](https://jira.nuxeo.com/browse/NXDRIVE-2333): Functional tests should be retried with only one process
- [NXDRIVE-2334](https://jira.nuxeo.com/browse/NXDRIVE-2334): Update the translation check script to verify only missing arguments
- [NXDRIVE-2560](https://jira.nuxeo.com/browse/NXDRIVE-2560): Add a code coverage GitHub Action on PRs
- [NXDRIVE-2600](https://jira.nuxeo.com/browse/NXDRIVE-2600): Improve `options.py` coverage
- [NXDRIVE-2601](https://jira.nuxeo.com/browse/NXDRIVE-2601): [Windows] Fix `test_valid_argument_value()` integration test

## Minor Changes

- Upgraded `docutils` from 0.16 to 0.17
- Upgraded `s3transfer` from 0.3.4 to 0.3.7
- Upgraded `urllib3` from 1.26.3 to 1.26.4

## Technical Changes

- Added `engine_uid` argument to `DirectTransferSessionFinished.__init__()`
- Added `remote_ref` argument to `DirectTransferSessionFinished.__init__()`
- Changed arguments types of `Engine.directTransferSessionFinished` signal from `(str)` to `(str, str, str)`
- Added `Notification.action_args`
- Changed arguments types of `NotificationService.triggerNotification ` signal from `(str, str)` to `(str, object)`
- Added `Options.use_idempotent_requests`
- Removed `Options.freezer`
- Added `State.crash_details`
- Added `Uploads.request_uid`
- Added metrics/constants.py::`CRASHED_TRACE`
- Added updater/\_\_init\_\_.py::`UpdateIntegrityError`
